<?php

require_once 'base/GepParccomunicadoEntityBase.php';

/**
 * This class has been auto-generated by Setforms
 *
 * @package Entity
 * @author  Setforms
 */
class GepParccomunicadoEntity extends GepParccomunicadoEntityBase
{


    const IDATIVO = 'S';
    const SEM_REGISTRO = 10;


    /**     ok
     * Retorna o novo codigo da tabela.
     *
     * @param integer $nrorg Numero da Organizacao.
     *
     * @return Ambigous <number, number>
     */
    public static function novoCodigoGepParccomunicado($nrorg){
        $codigo = Novocodigo::geraCodigo($nrorg, 'GEP_PARCCOMUNICADO', 10);
        return $codigo;
    }


    /**     ok
     * Insere o parceiro comunicado e forma.
     *
     * @param integer $codigo                   Codigo do registro.
     * @param integer $comunicado               Codigo da comunicacao.
     * @param integer $parceiro                 Codigo do parceiro comunicado escolhido.
     * @param integer $forma                    Forma de comunicacao. 05|02.
     * @param string  $nome_parc_inserido       Nome do parceiro comunicado.
     * @param integer $prefixo_parc_inserido    Prefixo do telefone.
     * @param string  $comunicado_parc_inserido Telefone ou email do parceiro que foi comunicado.
     * @param integer $operador                 Codigo do operador de insercao.
     * @param date    $data                     Data de insercao.
     * @param integer $nrorg                    N?mero da organizacao.
     *
     * @return boolean
     */
    public function insereParceiroComunicado(
        $codigo, $comunicado, $parceiro, $forma, $nome_parc_inserido,
        $prefixo_parc_inserido, $comunicado_parc_inserido, $operador,
        $data, $nrorg
    ){
        try {
            $obj = new GepParccomunicadoEntity();

            $obj->setNrparccomunicado($codigo);
            $obj->setNrcomunicacao($comunicado);
            $obj->setNrparcnegocio($parceiro);
            $obj->setCdformacomu($forma);
            $obj->setNmparccomunicado($nome_parc_inserido);
            $obj->setCdprefixcomuparc($prefixo_parc_inserido);
            $obj->setCdcomunicaparc($comunicado_parc_inserido);
            $obj->setNrorg($nrorg);
            $obj->setIdativo(self::IDATIVO);
            $obj->setDtinclusao($data);
            $obj->setNrorginclusao($nrorg);
            $obj->setCdoperinclusao($operador);
            $obj->setDtultatu($data);
            $obj->setNrorgultatu($nrorg);
            $obj->setCdoperultatu($operador);

            $obj->persist();

            return true;
        } catch (Exception $e) {
            tk_warning('Erro insert Gep_Parccomunciado: '.$e->getMessage());
            return false;
        }
    }


    /**
     * Retorna os parceiros de um comunicado.
     *
     * @param integer $nrorg      Numero da organizacao.
     * @param integer $comunicado Codigo do comunicado.
     *
     * @throws Exception Caso nao tenha parceiros para este comunicado.
     *
     * @return Ambigous <Ambigous, boolean, NULL, TkModelEntity>
     */
    public function retornaParceirosComu($nrorg, $comunicado){
        $parceiros = GepParccomunicado::consultaParceirosComu($nrorg, $comunicado);

        if (count($parceiros[0]) > 0) {
            return $parceiros;
        }

        throw new Exception('GepParccomunicadoEntity: Nao ha parceiros para este comunicado', self::SEM_REGISTRO);
    }


}

